﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Q1_AnimalWordle
{
    internal class Program
    {
        static void Main(string[] args)
        {
            while (true)
            {
                //Declare varaibles
                string[] animalArray = { "duck", "goat", "bear", "lion", "frog", "deer", "swan", "wolf", "crab" };
                bool playGame = false;
                bool playerHasWon = false;

                //Introduction
                Console.WriteLine("Welcome to Animal Wordle!");
                Console.WriteLine();
                Console.WriteLine("In animal wordle you will need to guess the name of a 4-letter animal within six attempts.");
                Console.WriteLine("Feedback will be given to you for each letter of the word you guessed.");
                Console.WriteLine();
                Console.WriteLine("If the character is in the correct position, it is indicated with a hash (#).");
                Console.WriteLine("If a character is correct, but in the wrong position, it is indicated with a hyphen (-).");
                Console.WriteLine("If a character is incorrect, it is represented with a full stop (.).");
                Console.WriteLine();

                //Player enters their name here
                Console.WriteLine("Please enter your name: ");

                string name = Console.ReadLine();

                Console.WriteLine();

                //Play or not
                while (true)
                {
                    Console.WriteLine("Welcome " + name + " would you like to play Animal Wordle (y/n)? ");
                    string yn = Console.ReadLine();
                    Console.WriteLine();

                    //Check if the users answer is yes, no or invalid
                    if (yn == "n" || yn == "N")
                    {
                        //Exits the application
                        Environment.Exit(0);
                    }
                    else if (yn == "y" || yn == "Y")
                    {
                        //Starts the game
                        playGame = true;
                        break;
                    }
                    else
                    {
                        //Makes the user input a valid answer
                        Console.WriteLine("Invalid input try again");
                        Console.WriteLine();
                    }
                }
                
                //Main gameplay loop
                while (playGame)
                {
                    //Set guesses to 6 and randomise the animal
                    int guessesLeft = 6;
                    Random random = new Random();
                    string selectedAnimal = animalArray[random.Next(animalArray.Length)];

                    Console.WriteLine("You have " + guessesLeft + " guesses remaining");

                    while (!playerHasWon && guessesLeft > 0)
                    {
                        Console.WriteLine("Please enter your four letter guess:");
                        Console.WriteLine();

                        //Ensures guesses aren't case sensitive
                        string guess = Console.ReadLine().ToLower();

                        //Check if guess is four letters
                        if (guess.Length != 4)
                        {
                            Console.WriteLine("Your guess must be a 4-letter word");
                            continue;
                        }

                        string result = "";

                        //Gets the results for each letter guess
                        for (int i = 0; i < 4; i++)
                        {
                            //Correct letter and position
                            if (guess[i] == selectedAnimal[i])
                            {
                                result += "#";
                            }
                            //Correct letter but incorrect position
                            else if (selectedAnimal.Contains(guess[i]))
                            {
                                result += "-";
                            }
                            //Incorrect letter and incorrect position
                            else
                            {
                                result += ".";
                            }
                        }

                        //Decrease guesses left by one
                        guessesLeft--;

                        //Display the result and how many guesses are left over
                        Console.WriteLine("Result: " + result);
                        Console.WriteLine("You have " + guessesLeft + " guesses remaining");

                        //Checks if the players word guess was correct
                        if (result == "####")
                        {
                            Console.WriteLine("Congratulations " + name + " the animal was: " + selectedAnimal);
                            Console.WriteLine();
                            playerHasWon = true;
                        }
                    }

                    //If player did not guess the word in six guesses
                    if (!playerHasWon)
                    {
                        //Display the correct answer and stop the game
                        Console.WriteLine("Game over! The correct animal was: " + selectedAnimal);
                        Console.ReadLine();
                    }

                    //Re-randomise the animal and restart the game
                    random = new Random();
                    selectedAnimal = animalArray[random.Next(animalArray.Length)];
                    break;
                }
            }
        }
    }
}
